package actions.userstorytree;

import actions.UserStoryToolAction;
import plugin.Controller;
import ui.UserStoryTreeView;

public class TreeShowActorsAction extends UserStoryToolAction
{
	public static final String NAME = "Toggle Showing User Stories by Actor";
	public static final String TOOLTIP = "Displays a hierarchy of Actors and their User Stories";
	public static final String IMAGE = "icons/actor.png";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.treeshowactorsaction";
	
	public TreeShowActorsAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		if(Controller.instance == null)
		{
			return;
		}
		
		UserStoryTreeView.showActors = !UserStoryTreeView.showActors;
		viewer.setInput(Controller.getDatabase().getRoot());
	}

}