package actions.userstorytree;

import org.eclipse.jface.viewers.ViewerSorter;

import actions.UserStoryToolAction;
import plugin.Controller;
import ui.UserStoryTreeViewerSorter;

@SuppressWarnings("deprecation")
public class TreeSortAction extends UserStoryToolAction {

	public static final String NAME = "Sort User Story Tree";
	public static final String TOOLTIP = "Sort the User Story Tree Alphabetically.";
	public static final String IMAGE = "icons/sort.gif";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.treesortaction";
	
	public TreeSortAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		if(Controller.instance == null){
			return;
		}			
		//Controller.getDatabase().sort();
		ViewerSorter temp = viewer.getSorter();
		if(temp instanceof UserStoryTreeViewerSorter){
			((UserStoryTreeViewerSorter)temp).sorter = !((UserStoryTreeViewerSorter)temp).sorter;
			viewer.setSorter(temp);
		}
		viewer.refresh();
		viewer.setExpandedElements(viewer.getExpandedElements());
		viewer.setExpandedTreePaths(viewer.getExpandedTreePaths());
	}

}
