package actions.userstorytree.actors;

import java.io.IOException;

import org.eclipse.jface.window.Window;

import actions.UserStoryToolAction;
import plugin.Controller;
import plugin.LogWriter;
import ui.dialogs.actors.ActorManagerDialog;

public class ActorManagerOpenAction extends UserStoryToolAction
{
	public static final String NAME = "Open Actor Manager";
	public static final String TOOLTIP = "Edit the Actors of this Project.";
	public static final String IMAGE = "icons/actor_manager.gif";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.actormanageropenaction";
	
	public ActorManagerOpenAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		ActorManagerDialog actorManagerDialog;
		try
		{
			if(Controller.instance == null){
				return;
			}
			actorManagerDialog = new ActorManagerDialog(viewer.getControl().getShell());
			actorManagerDialog.create();
			// OK Pressed on Dialog
			if (actorManagerDialog.open() == Window.OK)
			{
				return;
			}
		}
		catch (IOException e1) {
			LogWriter.high("UserStoryTreeView: Open actor Manager Dialog Action IOException" + e1.getMessage());
		}
	}
}
