package actions.userstorytree.link;

import actions.UserStoryToolAction;
import links.FoundJavaElement;
import links.LinkManager;
import links.RightClickContextManager;
import plugin.LogWriter;
import ui.UserStoryTreeView;

public class LinkSelectedMemberAction extends UserStoryToolAction
{
	public static final String NAME = "Link Selected Member";
	public static final String TOOLTIP = "Link Selected Member";
	public static final String IMAGE = "icons/lm.png";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.linkselectedmemberaction";
	
	public LinkSelectedMemberAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		FoundJavaElement selectedElement = RightClickContextManager.getSelectedMember();
		LinkManager.createLink(UserStoryTreeView.lastSelectionIndex.getAbsolutePath(), selectedElement.getAbsoluteFilePath(), selectedElement.getElementName(), selectedElement.getParentName());
		LogWriter.info("You selected " + selectedElement.getElementName() + " with type " + selectedElement.getElementType());
		viewer.refresh();
		//Controller.getDatabase().refresh();
		LogWriter.info("Finished RightClick Stuff. Hopefully this refreshes");							
	}
}