package actions.userstorytree.model;

import java.util.ArrayList;

import actions.UserStoryToolAction;
import copypaste.CopyPasteDB;
import model.Model;
import model.UsSystem;
import model.UserStory;
import plugin.Controller;
import ui.UserStoryTreeView;

public class ModelCopyAction extends UserStoryToolAction
{
	public static final String NAME = "Copy";
	public static final String TOOLTIP = "Copy User Stories and Systems";
	public static final String IMAGE = "icons/copy.gif";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.modelcopyaction";
	
	public ModelCopyAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		CopyPasteDB.copied = new ArrayList<Model>();
		
		for (int i = 0; i < viewer.getTree().getSelection().length; i++)
		{
			UserStoryTreeView.lastSelectionIndex = (Model) viewer.getTree().getSelection()[i].getData();
			
			if (UserStoryTreeView.lastSelectionIndex instanceof UsSystem || UserStoryTreeView.lastSelectionIndex instanceof UserStory)
			{
				if (!UserStoryTreeView.lastSelectionIndex.equals(Controller.getDatabase().getRoot()))
				{
					CopyPasteDB.copied.add(UserStoryTreeView.lastSelectionIndex.getCopy());
				}
			}
			else
			{
				UserStoryTreeView.showMessage("You cannot copy a link");
			}
		}
	}
}
