package actions.userstorytree.model;

import java.util.ArrayList;

import actions.UserStoryToolAction;
import copypaste.CopyPasteDB;
import history.HistoryManager;
import model.Model;
import model.UsSystem;
import plugin.Controller;
import plugin.Database;
import ui.UserStoryTableViewer;
import ui.UserStoryTreeView;

public class ModelPasteAction extends UserStoryToolAction
{
	public static final String NAME = "Paste";
	public static final String TOOLTIP = "Paste User Stories and Systems.";
	public static final String IMAGE = "icons/paste.gif";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.modelpasteaction";
	
	public ModelPasteAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		ArrayList<Model> newCopyUserStory = CopyPasteDB.copied;
		if (newCopyUserStory != null) {
			
			if(!(UserStoryTreeView.lastSelectionIndex instanceof UsSystem))
			{
				return;
			}
			
			for (int i = 0; i < newCopyUserStory.size(); i++)
			{
				Model newCopy = newCopyUserStory.get(i);
				UsSystem where = (UsSystem)UserStoryTreeView.lastSelectionIndex;
				newCopy.setParentAbsolutePath(where.getAbsolutePath());
				Controller.getDatabase().restoreModel(newCopy, where.getAbsolutePath());
				Controller.getDatabase().adjustPathsToParentChange(where);
				UserStoryTableViewer.Refresh();
			}
			
			HistoryManager.createHistory(newCopyUserStory, HistoryManager.addHistory);
		}
		else
		{
			UserStoryTreeView.showMessage("nothing to paste");
		}
		newCopyUserStory = null;				
		viewer.refresh();
	}
}