package actions.userstorytree.system;

import java.util.ArrayList;

import org.eclipse.jface.window.Window;

import actions.UserStoryToolAction;
import editor.MultiCreator;
import plugin.Controller;
import ui.UserStoryTreeView;

public class SystemCreateTopLevelAction extends UserStoryToolAction
{
	public static final String NAME = "Create Top-Level System";
	public static final String TOOLTIP = "Create a System in the top level of the Tree View.";
	public static final String IMAGE = "icons/folder_add.png";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.system.createtoplevelaction";
	
	public SystemCreateTopLevelAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		MultiCreator crtDialog = new MultiCreator(viewer.getControl().getShell(), MultiCreator.TYPE_SYSTEM);
		crtDialog.create();
		if (crtDialog.open() == Window.OK)
		{
			ArrayList<String> names = crtDialog.getNames();
			for(String name : names){
				Controller.getDatabase().createRootSystem(name);
			}
			viewer.refresh();
			UserStoryTreeView.userStoryEditAction.run();
		}
	}
}