package actions.userstorytree.system;

import java.util.ArrayList;

import org.eclipse.jface.window.Window;

import actions.UserStoryToolAction;
import editor.MultiCreator;
import model.Model;
import plugin.Controller;
import ui.UserStoryTreeView;

public class SystemCreateUnderSelectionAction extends UserStoryToolAction
{
	
	public static final String NAME = "Create System under selection";
	public static final String TOOLTIP = "";
	public static final String IMAGE = "icons/folder_add.png";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.system.createunderselectionaction";
	
	public SystemCreateUnderSelectionAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		Model parent = UserStoryTreeView.lastSelectionIndex;
		MultiCreator crtDialog = new MultiCreator(viewer.getControl().getShell(), MultiCreator.TYPE_SYSTEM);
		crtDialog.create();
		if (crtDialog.open() == Window.OK)
		{
			ArrayList<String> names = crtDialog.getNames();
			for(String name : names)
			{
				Controller.getDatabase().createSystem(name,parent.getAbsolutePath());						
			}
			viewer.refresh();
			UserStoryTreeView.userStoryEditAction.run();
		}
	}
}