package actions.userstorytree.userstory;

import java.util.ArrayList;

import org.eclipse.jface.window.Window;

import actions.UserStoryToolAction;
import editor.MultiCreator;
import model.Model;
import plugin.Controller;
import plugin.config.PreferencesManager;
//import plugin.config.UserStoryToolPreferenceManager;
import ui.UserStoryTreeView;

public class UserStoryCreateAction extends UserStoryToolAction
{
	public static final String NAME = "Create UserStory under selection";
	public static final String TOOLTIP = "Creates a User Story under the selected System";
	public static final String IMAGE = "icons/userstory_add.png";
	public static final String COMMAND_ID = "com.userstoriestool.userstorytree.userstory.createaction";
	
	public UserStoryCreateAction()
	{
		super(NAME, TOOLTIP, IMAGE, COMMAND_ID);
	}
	
	public void run()
	{
		Model parent = UserStoryTreeView.lastSelectionIndex;
		
		MultiCreator crtDialog = new MultiCreator(viewer.getControl().getShell(), MultiCreator.TYPE_USER_STORY);
		
		crtDialog.create();
		
		if (crtDialog.open() == Window.OK)
		{
			ArrayList<String> names = crtDialog.getNames();
			for(String name : names)
			{
				Controller.getDatabase().createUserStory(name,parent.getAbsolutePath());
			}
			viewer.refresh();
		}
		if (PreferencesManager.getOpenEditorOnAdd())
		{
			UserStoryTreeView.userStoryEditAction.run();	
		}
					
	}
}

