package dragAndDrop;
import java.util.ArrayList;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredViewer;
import org.eclipse.swt.dnd.DragSourceAdapter;
import org.eclipse.swt.dnd.DragSourceEvent;

import actors.Actor;
import model.LinkStub;
import model.Model;
/**
 * Supports dragging gadgets from a structured viewer.
 */
public class UserStoryDragListener extends DragSourceAdapter {
   private StructuredViewer viewer;
   
   public UserStoryDragListener(StructuredViewer viewer) {
      this.viewer = viewer;
   }
   /**
    * Method declared on DragSourceListener
    */
   public void dragFinished(DragSourceEvent event) {
         viewer.refresh();
   }
   /**
    * Method declared on DragSourceListener
    */
public void dragSetData(DragSourceEvent event) {
      IStructuredSelection selection = (IStructuredSelection)viewer.getSelection();
      ArrayList<Model> stories = new ArrayList<Model>();  
 
      for(int i = 0;i<selection.size();i++){
    	  if(!(selection.toList().get(i) instanceof LinkStub || selection.toList().get(i) instanceof Actor)){
    		  stories.add((Model) selection.toList().get(i));
    	  }
      }    	
      if (UserStoryTransferType.getInstance().isSupportedType(event.dataType)) {
         event.data = stories;
      }
   }
   /**
    * Method declared on DragSourceListener
    */
   public void dragStart(DragSourceEvent event) {
      event.doit = !viewer.getSelection().isEmpty();
   }
}