package dragAndDrop;


import java.io.IOException;
import java.util.ArrayList;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerDropAdapter;
import org.eclipse.swt.dnd.TransferData;

import history.HistoryManager;
import model.Model;
import model.UsSystem;
import model.UserStory;
import plugin.Controller;

public class UserStoryTreeDropAdapter extends ViewerDropAdapter{

	public UserStoryTreeDropAdapter(Viewer viewer) {
		super(viewer);
	}

	@Override
	public boolean performDrop(Object data) {
		if(!(getCurrentTarget() instanceof UsSystem))
			return false;
		UsSystem target = (UsSystem)getCurrentTarget();
	      if (target == null){
	         return false;
	      }
	      if(data == null){
	    	  return false;
	      }
	     /* if(target instanceof LinkedDeclaration){
	    	  return false;
	      }*/
	      if(DragAndDropDB.us != null){
	    	  ArrayList<Model> oldhistory = new ArrayList<Model>(); 
	    	  ArrayList<Model> newhistory = new ArrayList<Model>();
	    	  for(Model move : DragAndDropDB.us){
	    		  if(!target.equals(move)){
	    			  if(!checkChildren(target,move)){
	    				  oldhistory.add(move.getCopy());
	    				  Controller.getDatabase().deleteModel(move);
	    				  Controller.getDatabase().restoreModel(move, target.getAbsolutePath());
	    				  newhistory.add(move.getCopy());				    	
	    			  }else{
		    			  //LogFileWriter.write("Cannot drop the user story to it's children (Drag And Drop support)", LogFileWriter.SEVERITY_INFO);
		    		  }
	    		  }else{
	    			  //LogFileWriter.write("Cannot drop the user story to itself (Drag And Drop support)", LogFileWriter.SEVERITY_INFO);
	    		  }
	    	  }
	    	  HistoryManager.createHistory(newhistory, oldhistory, HistoryManager.editHistory);
	    	  DragAndDropDB.us.clear();
	    	  //UserStoryTreeView.refresh();
	    	  try {
				target.saveToDisk(target.getAbsolutePath());
			} catch (IOException e) {
				e.printStackTrace();
			}
	      }else{
	    	  DragAndDropDB.us.clear();
	    	  //LogFileWriter.write("Nothing to drop (Drag And Drop support)", LogFileWriter.SEVERITY_LOW);
	    	  return false;
	      }
	      
	      return true;
	}

	@Override
	public boolean validateDrop(Object target, int arg1, TransferData type) {
		 return UserStoryTransferType.getInstance().isSupportedType(type);
	}
	private boolean checkChildren(Model target,Model transfered){
		boolean found = false;
		if(!(target instanceof UsSystem)){
			return true;
		}
		if(transfered instanceof UserStory){
			if(transfered.equals(target)){
				return true;
			}else
				return false;
					
		}
		for(Model child : ((UsSystem)transfered).getChildrenList()){
			if(child.equals(target)){
				return true;
			}else{
				found = checkChildren(target,child);
				if(found == true){
					return found;
				}
			}			
		}
		return found;
	}
}
