package editor;

import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.ColumnViewer;
import org.eclipse.jface.viewers.EditingSupport;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;

import model.TestCase;

public class TestCasesEditingSupport extends EditingSupport {

	private final TableViewer viewer;
	private final CellEditor editor;
	private int column = 0;
	private UserStoryEditor usEditor;
	public static int ChangeName = 0;
	public static int ChangeDescription = 1;
	public static int ChangeResults = 2;
	public static int ChangeRemoteManagement = 3;
	
	public TestCasesEditingSupport(ColumnViewer viewer,int column,UserStoryEditor temp) {
		 super(viewer);
	     this.viewer = (TableViewer) viewer;
	     this.column = column;
	     this.editor = new TextCellEditor(((TableViewer) viewer).getTable());
	     usEditor = temp;
	}

	@Override
	protected boolean canEdit(Object arg0){
		return true;
	}

	@Override
	protected CellEditor getCellEditor(Object arg0) {
		return editor;
	}

	@Override
	protected Object getValue(Object element) {
		if(column == 0){
			return ((TestCase)element).getId();
		}else if(column == 1){
			return ((TestCase)element).getDescription();
		}else if(column == 2){
			return ((TestCase)element).getExpectedResults();
		}
		return ((TestCase)element).getRemoteManagement();
	}

	@Override
	protected void setValue(Object element, Object userInputValue) {
		if(column == 0){
			((TestCase) element).setId(String.valueOf(userInputValue));
		}else if(column == 1){
			((TestCase) element).setDescription(String.valueOf(userInputValue));
		}else if (column == 2){			
			((TestCase) element).setExpectedResults(String.valueOf(userInputValue));
		}else{
			((TestCase) element).setRemoteManagement(String.valueOf(userInputValue));
		}
	    viewer.update(element, null);
	    usEditor.dirty();
	}

}
