package history;

import java.util.ArrayList;
import model.Model;
import plugin.Controller;

public class HistoryManager {	
	private static ArrayList<History> history = new ArrayList<History>(); //Stories which have been deleted or added.
	private static ArrayList<History> redoHistory = new ArrayList<History>();
	public static String editHistory = "edit";
	public static String addHistory = "add";
	public static String deleteHistory = "delete";
	
	public static void createHistory(ArrayList<Model> createStory, String historyAction){// remove - add
		if(history.size() == 50){
			history.remove(0);
		}
		History createHistory = new SimpleHistory(createStory,historyAction);
		history.add(createHistory);
	}
	public static void createHistory(Model createStory, String historyAction){// remove - add
		ArrayList<Model> historyToBeCreated = new ArrayList<Model>();
		historyToBeCreated.add(createStory);
		createHistory(historyToBeCreated,historyAction);
	}
	public static void createHistory(ArrayList<Model> createStory,ArrayList<Model> oldStory, String historyAction){ // edit
		if(history.size() == 50){
			history.remove(0);
		}
		History createHistory = new ExtendedHistory(createStory,oldStory,historyAction);
		history.add(createHistory);
	}	
	public static void createHistory(Model createStory,Model oldStory, String historyAction){ // edit
		ArrayList<Model> historyToBeCreated = new ArrayList<Model>();
		historyToBeCreated.add(createStory);
		ArrayList<Model> oldStories = new ArrayList<Model>();
		oldStories.add(oldStory);
		createHistory(historyToBeCreated,oldStories,historyAction);		
	}
	public static void undoHistory(){
		if(history.size() > 0){
			History revive = history.get(history.size()-1);
			if(revive instanceof SimpleHistory){
				for(Model story : revive.getOldStory()){
					if(revive.getAction().equals(addHistory)){ //If the action was to add a User Story
						Controller.getDatabase().deleteModel(story);					
					}else if(revive.getAction().equals(deleteHistory)){ //If the action was to delete a User Story
						Controller.getDatabase().restoreModel(story,"");
					}
				}
			}else if(revive instanceof ExtendedHistory){
				for(Model deleteThis : ((ExtendedHistory)revive).getNewStory()){
					//The new User Story that took the place of old User Story
					Controller.getDatabase().deleteModel(deleteThis);
				}
				for(Model reviveThis : ((ExtendedHistory)revive).getOldStory()){
					//The old User Story that has been lost
					Controller.getDatabase().restoreModel(reviveThis,"");
				}
			}			
			redoHistory.add(history.get(history.size()-1).swapToFuture());
			history.remove(history.size()-1);
		}
	}
	public static void redoHistory(){
		if(redoHistory.size() > 0){
			History revive = redoHistory.get(redoHistory.size()-1);
			if(revive instanceof SimpleHistory){
				for(Model story : revive.getOldStory()){
					if(revive.getAction().equals(addHistory)){ //If the action was to add a User Story
						Controller.getDatabase().deleteModel(story);					
					}else if(revive.getAction().equals(deleteHistory)){ //If the action was to delete a User Story
						Controller.getDatabase().restoreModel(story,"");
					}
				}
			}else if(revive instanceof ExtendedHistory){
				for(Model deleteThis : ((ExtendedHistory)revive).getNewStory()){
					//The new User Story that took the place of old User Story
					Controller.getDatabase().deleteModel(deleteThis);
				}
				for(Model reviveThis : ((ExtendedHistory)revive).getOldStory()){
					//The old User Story that has been lost
					Controller.getDatabase().restoreModel(reviveThis,"");
				}
			}
			history.add(redoHistory.get(redoHistory.size()-1).swapToFuture());
			redoHistory.remove(redoHistory.size()-1);
			
		}
	}
}
