package links;

import org.eclipse.jdt.core.IJavaElement;

import plugin.Controller;

public class FoundJavaElement
{
	private String absoluteFilePath;
	private String elementName;
	private String elementType;
	private FoundJavaElement parent;
	
	public FoundJavaElement(String absoluteFilePath, String elementName, int elementType)
	{
		this.absoluteFilePath = absoluteFilePath;
		this.elementName = elementName;
		this.elementType = Controller.getJavaElementDict(elementType);
	}

	@Override
	public String toString() {
		return "FoundJavaElement [absoluteFilePath=" + absoluteFilePath + ", elementName=" + elementName
				+ ", elementType=" + elementType + "]" + parent;
	}
	
	

	public String getAbsoluteFilePath() {
		return absoluteFilePath;
	}

	public String getElementName() {
		return elementName;
	}

	public String getElementType() {
		return elementType;
	}

	public FoundJavaElement getParent() {
		return parent;
	}
	
	public String getParentName()
	{
		if (this.parent == null)
		{
			return "";
		}
		else
		{
			return this.parent.getElementName();
		}
	}

	public void setParent(IJavaElement elementParent)
	{
		if (elementParent !=null)
		{
			this.parent = new FoundJavaElement(this.absoluteFilePath, elementParent.getElementName(), elementParent.getElementType());
		}
	}
	
	
	
	
}
