package model;

import java.io.File;
import java.util.ArrayList;

import plugin.Controller;
import plugin.LogWriter;
import plugin.config.PreferencesManager;

public class Project
{
	public static final String rootProject = "us_project\\__root__/";
	private String name;
	private String projectPath;
	private boolean hasUserStories;
	// Children are only used for the ProjectTreeViewer
	public ArrayList<Project> children;

	public Project(String name, String projectPath)
	{
		this.name = name;
		this.projectPath = projectPath;
		this.children = new ArrayList<Project>();
		if (!this.projectPath.equals(rootProject))
		{
			this.checkUserStories();
		}
	}
	
	public void checkUserStories()
	{
		File f = new File(this.projectPath+"\\"+Controller.PATH_DIR_US_ROOT);
		if (f.exists() && f.isDirectory())
		{
			this.hasUserStories = true;
			return;
		}
		this.hasUserStories = false;
	}
	
	
	
	public boolean getHasUserStories() {
		return hasUserStories;
	}

	public Object[] getChildren()
	{
		return children.toArray();
	}

	public String getProjectPath() {
		return projectPath;
	}

	public String getName() {
		return name;
	}
	
	public boolean isDefault()
	{
		LogWriter.debug("Project: isDefault(): Comparing " + this.name + " with " + PreferencesManager.getDefaultProject());
		return this.name.equals(PreferencesManager.getDefaultProject());
	}
}
