package plugin;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.StandardOpenOption;

public class LogWriter
{
	public static String logFilePath = "";
	public static String SEVERITY_DEBUG = "Debug";
	public static String SEVERITY_INFO = "Info";
	public static String SEVERITY_WARNING = "Warning";
	public static String SEVERITY_LOW = "Low";
	public static String SEVERITY_MEDIUM = "Medium";
	public static String SEVERITY_HIGH = "High";
	
	private static int numberOfLines = 0;	
	
	@SuppressWarnings("static-access")
	public static void write(String value,String severity)
	{
		System.out.println(severity + "\t "+ value);
		
		if (severity.equals(SEVERITY_DEBUG) || Controller.getInstance().projectPath == null)
		{
			return;
		}
		
		if (logFilePath.equals(""))
		{
			File f = Controller.getInstance().getFile(Controller.PATH_FILE_LOG);
			logFilePath = f.getAbsolutePath();
		}
		
		File log = new File(logFilePath);
		
		if(!log.exists())
		{
			try
			{
				log.createNewFile();
			}
			catch (IOException e)
			{
				System.err.println("LogFileWriter: write(): Couldn't create file: " + logFilePath);
			}
		}
		
		try
		{
			numberOfLines = Files.readAllLines(log.toPath(), Charset.defaultCharset()).size();
			String line = "\n"+numberOfLines + " severity : " + severity + " : " + value;
			Files.write(log.toPath(),line.getBytes(),StandardOpenOption.APPEND);
		}
		catch (IOException e)
		{
			System.err.println("LogFileWriter: write(): Couldn't write on log file");
		}		
	}
	
	//Helper Methods
	public static void warning(String message){write(message, SEVERITY_WARNING);}
	public static void low(String message){write(message, SEVERITY_HIGH);}
	public static void medium(String message){write(message, SEVERITY_MEDIUM);}
	public static void high(String message){write(message, SEVERITY_WARNING);}
	public static void info(String message){write(message, SEVERITY_INFO);}
	public static void debug(String message){write(message, SEVERITY_DEBUG);}
}
