package plugin;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.swt.widgets.Display;

import model.Project;
import ui.dialogs.projectselection.ProjectTreeDialog;

public class ProjectDatabase implements Runnable
{
	public static Thread THREAD_PROJECT_DATABASE;
	public static ProjectDatabase instance;
	public static Project rootProject;
	public static boolean controllerWaitForMe;
	public ProjectDatabase()
	{
		 controllerWaitForMe = true;
		 instance = this;
		 rootProject = new Project(Project.rootProject, Project.rootProject);
		 
		 THREAD_PROJECT_DATABASE = new Thread(this, "Project Database Thread");
		 THREAD_PROJECT_DATABASE.start();	 		
	}
	
	public void run()
	{
		// Get array of Projects from the Workspace
		IProject[] projectArray = ResourcesPlugin.getWorkspace().getRoot().getProjects();
		LogWriter.debug("ProjectDatabase: Got array");
		
		// If we've got more than 0 projects, we can add them to the list
		if (projectArray.length > 0)
		{
			LogWriter.debug("ProjectDatabase: Checking Projects");
			for (IProject project : projectArray)
			{
				String absolutePath = project.getLocation().toString();
				
				LogWriter.debug("ProjectDatabase: Found: \'" + absolutePath + "\'" );
				rootProject.children.add(new Project(project.getName(), absolutePath));
			}
		}
		
		controllerWaitForMe = false;
		
		new Thread(new Runnable() {
			public void run()
			{
				Display.getDefault().asyncExec(new Runnable()
				{
					public void run()
					{
						if(ProjectTreeDialog.projectTreeViewer != null)
							ProjectTreeDialog.projectTreeViewer.setInput(rootProject);
					}
				});
			}
		}).start();
	}
}
