package plugin.config;

public class Preference
{
	public String id;
	public Object currentValue;
	public Object defaultValue;
	
	// One value given = default
	public Preference(String id, Object value)
	{
		this.id = id;
		this.currentValue = value;
		this.defaultValue = value;		
	}
	
	public Preference(String id, Object currentValue, Object defaultValue)
	{
		this.id = id;
		this.currentValue = currentValue;
		this.defaultValue = defaultValue;		
	}
	
	public String getId()
	{
		return id;
	}

	public String getValue()
	{
		return this.currentValue.toString();
	}
	
	public String getDefaultValue()
	{
		return this.defaultValue.toString();
	}
	
	// IDs that correspond to these preferences.
	public static final String default_project = "default_project";
	public static final String show_conversion_confirmation_dialog = "show_conversion_confirmation_dialog";
	public static final String show_delete_confirmation_dialog = "show_delete_confirmation_dialog";
	public static final String show_test_case_cancel_confirmation_dialog = "show_test_case_cancel_confirmation_dialog";
	public static final String open_editor_on_add = "open_editor_on_add";
	public static final String table_show_systems = "table_show_systems";
	public static final String table_show_linked_classes = "table_show_linked_classes";
	public static final String table_show_linked_methods = "table_show_linked_methods";

	// Defaults for each ID
	public static final String default_default_project = "";
	public static final boolean default_show_conversion_confirmation_dialog = true;
	public static final boolean default_show_delete_confirmation_dialog = true;
	public static final boolean default_show_test_case_cancel_confirmation_dialog = true;
	public static final boolean default_open_editor_on_add = true;
	public static final boolean default_table_show_systems = true;
	public static final boolean default_table_show_linked_classes = true;
	public static final boolean default_table_show_linked_methods = true;
}
