package ui;

import java.util.ArrayList;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import actors.Actor;
import actors.ActorManager;
import model.*;
import plugin.Controller;

public class UserStoryContentProvider implements ITreeContentProvider {
	@SuppressWarnings("unused")
	private static Object[] EMPTY_ARRAY = new Object[0];
	protected TreeViewer viewer;
	private int currentActor = -1; //if showActors is true	
	/*
	 * @see IContentProvider#dispose()
	 */
	public void dispose() {}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput){
	}
	
	/*public static void remove(TreeItem parent){
		if(parent.getData() instanceof UsSystem){
			for(TreeItem child : parent.getItems()){
				remove(child);
			}
			for(int i = 0 ; i < parent.getItems().length; i++){
				if(parent.getItems()[i].getData() instanceof UsSystem){
					if(((UsSystem)parent.getItems()[i].getData()).getChildrenList().size() == 0){
						parent.getItems()[i].dispose();
					}
				}
			}
		}
	}*/
	@Override
	public Object[] getElements(Object inputElement)
	{
		if(UserStoryTreeView.showActors){
			Object[] returnThis = ActorManager.getAllActors().toArray();
			return returnThis;
		}
		return getChildren(inputElement);
	}

	@Override 
	public Object[] getChildren(Object parentElement)
	{
		if (parentElement instanceof UsSystem)
		{	if(UserStoryTreeView.showActors){		
				ArrayList<Model> childrenOfActors = new ArrayList<Model>();
				for(Model child : ((UsSystem)parentElement).getChildrenList()){
					if (child instanceof UserStory){
						if(((UserStory)child).getActors().contains(currentActor)){
							childrenOfActors.add(child);
						}
					}else{
						childrenOfActors.add(child);
					}
				}
				return childrenOfActors.toArray();
			}
			return ((UsSystem) parentElement).getChildren();
		}
		else if (parentElement instanceof UserStory) 
		{
			return ((UserStory) parentElement).getChildren();
		}
		else if (parentElement instanceof LinkStub)		{
			return ((LinkStub) parentElement).getChildren();
		}
		else if(parentElement instanceof Actor){
			currentActor = ((Actor)parentElement).getId();
			ArrayList<Model> childrenOfActors = new ArrayList<Model>();
			for(Model child : Controller.getDatabase().getRoot().getChildrenList()){
				if (child instanceof UserStory){
					if(((UserStory)child).getActors().contains(((Actor)parentElement).getId())){
						childrenOfActors.add(child);
					}
				}else{
					childrenOfActors.add(child);
				}
			}
			return childrenOfActors.toArray();
		}
		return null;
	}

	@Override
	public Object getParent(Object element)
	{
		if (element instanceof Model)
		{
			String parent_path = ((Model)element).getParentAbsolutePath();
			return Controller.getDatabase().getModel(parent_path);
		}
		return null;
	}

	@Override
	public boolean hasChildren(Object element) {
		if (element instanceof UsSystem)
		{
			return ((UsSystem) element).getChildren().length > 0;
		}
		else if (element instanceof UserStory)
		{
			return ((UserStory) element).getLinks().size() > 0;
		}
		else if (element instanceof LinkStub)
		{
			return ((LinkStub) element).getChildren().length > 0;
		}
		else if (element instanceof Actor){
			return true;
		}
		return false;
	}

	

}
