package ui.dialogs;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

public class ModelCreateDialog extends Dialog
{
	public static String WINDOW_NAME = "Creating new ";
	public static final String LABEL_SAVE_CHANGES = "OK";
	
	public static final String model_ussystem = "UsSystem";
	public String value;
	
	static Button buttonSaveChanges;
	static Button buttonCancel;
	
	static Text inputBox;
	
	//Custom Button IDs
	public static final int BUTTON_SAVE_ID = IDialogConstants.CLIENT_ID+1;
	
	public ModelCreateDialog(Shell parentShell)
	{
		super(parentShell);
	}
	
	@Override
	protected boolean isResizable()
	{
	    return true;
	}
	
	@Override
	protected void configureShell(Shell newShell)
	{
	      super.configureShell(newShell);
	      newShell.setText(WINDOW_NAME);
	}
	
	@Override
	protected Control createDialogArea(Composite parent)
	{
		GridData gridData = new GridData(GridData.FILL, GridData.CENTER, true, true);
		GridLayout layout = new GridLayout(1, true);
		final Composite container = (Composite) super.createDialogArea(parent);
        container.setLayout(layout);
		container.setLayoutData(gridData);

		final Composite widgetComposite = new Composite(container, SWT.PUSH);
		widgetComposite.setLayout(new GridLayout(2, false));
		widgetComposite.setLayoutData(new GridData(GridData.CENTER, GridData.CENTER, true, false));
		
		final Label labelPrompt = new Label(widgetComposite, SWT.NONE);
        labelPrompt.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
        labelPrompt.setText( "Please enter a name: " );

        inputBox = new Text(widgetComposite, SWT.BORDER);
        GridData gd = new GridData(SWT.FILL, SWT.CENTER, true, false);
        inputBox.setLayoutData(gd);
        inputBox.setFocus();
		
		return container;
	}
	
	public void setTypeOfModel(String type)
	{
		if (type.equals(model_ussystem))
		{
			WINDOW_NAME = "Creating new System";
		}
		else
		{
			WINDOW_NAME = "Creating new User Story";
		}
	}
	
	public String getValue()
	{
		return value;
	}
	
	
	protected void createButtonsForButtonBar(final Composite parent)
	{
	  // Change parent layout data to fill the whole bar
	  parent.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

	  buttonSaveChanges = createButton(parent, BUTTON_SAVE_ID, LABEL_SAVE_CHANGES , false);
	  buttonSaveChanges.addListener(SWT.Selection, new Listener() {
	      public void handleEvent(Event e) {
		        switch (e.type) {
		        case SWT.Selection:
		        	//TODO: CREATE SYSTEM
		        	value = inputBox.getText();
		        	if (value.equals(""))
		        	{
		        		return;
		        	}
	        		parent.getShell().dispose();
		        }
		      }
		    });
	  
	  buttonCancel = createButton(parent, IDialogConstants.CANCEL_ID,"Cancel", false);
	}



}
