package ui.dialogs;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import plugin.config.PreferencesManager;

public class ModelDeleteWarningDialog extends Dialog
{

	@SuppressWarnings("unused")
	@Deprecated
	private boolean deleteUs;
	
	private static String LABEL_WARNING;
	private static String DIALOG_TITLE = "Are you sure?";

	private static final String[] DIALOG_TITLE_PARTS = {"Confirm deletion of ", " object", " objects"};
	private static final String LABEL_INFO_SINGULAR = "Are you sure you want to delete this object and its children?";
	private static final String LABEL_INFO_PLURAL = "Are you sure you want to delete these objects and their children?";
	@SuppressWarnings("unused")
	private static Composite container;
	
	@SuppressWarnings("static-access")
	public ModelDeleteWarningDialog(Shell parentShell, String warning, boolean deleteUs)
	{
		super(parentShell);
		
		// If multipleObjects is true, plural number of objects.
		this.LABEL_WARNING = warning;
		this.deleteUs = deleteUs;
	}
	
	@SuppressWarnings("static-access")
	public ModelDeleteWarningDialog(Shell parentShell, int multipleObjects, boolean deleteUs)
	{
		super(parentShell);
		
		// If multipleObjects is true, plural number of objects.
		this.LABEL_WARNING = multipleObjects > 1 ? LABEL_INFO_PLURAL : LABEL_INFO_SINGULAR;
		// Welp
		DIALOG_TITLE = DIALOG_TITLE_PARTS[0] + Integer.toString(multipleObjects) + ((multipleObjects > 1) ? DIALOG_TITLE_PARTS[2] : DIALOG_TITLE_PARTS[1]);
		this.deleteUs = deleteUs;
	}
	
	@Override
	protected boolean isResizable()
	{
	    return true;
	}
	@Override
	protected Point getInitialSize()
	{
		return new Point(400, 150);
	}
	
	@Override
	protected void configureShell(Shell newShell)
	{
	      super.configureShell(newShell);
	      newShell.setText(DIALOG_TITLE);
	}
	
	@Override
	protected Control createDialogArea(Composite parent)
	{		
		Composite container = (Composite) super.createDialogArea(parent);
        
		Label warningLabel = new Label(container,SWT.NONE);
		warningLabel.setText(LABEL_WARNING);
		Button dontShowAgain = new Button(container,SWT.CHECK);
		dontShowAgain.setText("Do not show this message again.");
		dontShowAgain.addSelectionListener(new SelectionAdapter(){
			@Override
			public void widgetSelected(SelectionEvent event)
			{
				Button btn = (Button) event.getSource();
				PreferencesManager.setShowDeleteDialog(!btn.getSelection());
			}
			
		});
		return parent;
	}
			/*
	protected void createButtonsForButtonBar(final Composite parent)
	{
	  createButton(container, IDialogConstants.OK_ID, "Delete" , false);	  
	  createButton(container, IDialogConstants.CANCEL_ID,"Cancel", false);
	}*/

}

/*if(deleteUs){
Button deleteOnDisk = new Button(parent,SWT.CHECK);
deleteOnDisk.setText("Delete this object on disk");
deleteOnDisk.addSelectionListener(new SelectionAdapter(){
	@Override
	public void widgetSelected(SelectionEvent event) {
		Button btn = (Button) event.getSource();
		if(btn.getSelection()){
        	 MyPreferences.DELETE_STORIES_IN_DISK = true;			  
         }else{
        	 MyPreferences.DELETE_STORIES_IN_DISK = false;
         }
	}
});				
}*/
