package ui.dialogs;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.layout.GridDataFactory;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import model.*;
import ui.UserStoryTreeView;

public class ModelViewDebugDialog extends Dialog
{
	//Combo DropDownList;
	public static Model currentModel;
	
	public static final String LABEL_NAME = "Requirement Name: ";
	public static final String LABEL_DESCRIPTION = "Description: ";
	
	public static final String LABEL_ACTOR = "Actor: ";
	public static final String LABEL_ACTORS = "Actors: ";
	
	public static final String LABEL_PATH = "Location on disk: ";
	public static final String LABEL_CANONICAL_UID = "UID: ";
	
	public static final String LABEL_CLASS = "Class: ";
	public static final String LABEL_METHOD = "Method: ";
	
	public static final String LABEL_DEV_ID = "Sort ID: ";
	public static final String LABEL_DEV_NUMERICAL_UID = "Numerical UID: ";
	public static final String LABEL_DEV_PARENT_UID = "Parent UID: ";
	public static final String LABEL_DEV_CHILDREN_NODES = "Children Nodes: ";
	
	public ModelViewDebugDialog(Shell parentShell)
	{
		super(parentShell);
		currentModel = UserStoryTreeView.lastSelectionIndex;
		
		//TODO debug thing
		//JsonManager.writeJsonToFile(currentModel);
	}

	@Override
	protected Control createDialogArea(Composite parent)
	{
		Composite container = (Composite) super.createDialogArea(parent);
		GridData gridData = new GridData(GridData.FILL, GridData.CENTER, true, true);
		gridData.minimumWidth = 500;
		gridData.minimumHeight = 400;
		GridLayout layout = new GridLayout(1,true);
		layout.marginRight = 5;
		layout.marginLeft = 10;
				
		container.setLayout(layout);
		container.setLayoutData(gridData);
		
		//Name
		Label lblUserStory = new Label(container, SWT.NONE);
		lblUserStory.setText(LABEL_NAME + currentModel.getName());
		
		//Description
		Label lblDescription = new Label(container, SWT.NONE);
		lblDescription.setText(LABEL_DESCRIPTION);
		
	    StyledText descriptionContents = new StyledText(container, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL | SWT.WRAP | SWT.READ_ONLY);
	    descriptionContents.setLayoutData(GridDataFactory.fillDefaults().grab(false, false).span(1, 1).create());
	    descriptionContents.setText(currentModel.getDescription());
	    
	    if (currentModel instanceof UserStory)
		{
			//Actor
			Label lblActor = new Label(container,SWT.NONE);
			
			//Get all actor names
			String actorsNames = "";
			for (int actorID : ((UserStory) currentModel).getActors())
			{
				actorsNames += actorID;
			}
			//Cut off the last ", "
			if (actorsNames.length() > 2)
			{
				actorsNames = actorsNames.substring(0, actorsNames.length()-2);
				/*if (((UserStory) currentModel).getActors().size()>1)
				{
					lblActor.setText(LABEL_ACTORS + actorsNames );
				}
				else
				{*/
				lblActor.setText(LABEL_ACTOR + actorsNames );
				//}
			}
			else
			{
				lblActor.setText(LABEL_ACTOR + "None" );
			}
		}
		//Path		
		Label lblPath = new Label(container,SWT.NONE);
		lblPath.setText(LABEL_PATH + currentModel.getAbsolutePath());

		//Parent Absolute Path
		Label lblParent = new Label(container,SWT.NONE);
		lblParent.setText(LABEL_DEV_PARENT_UID + currentModel.getParentAbsolutePath());
		
		//Children Nodes
		Label lblChilds = new Label(container,SWT.NONE);
		lblChilds.setText(LABEL_DEV_CHILDREN_NODES + currentModel.getChildren().length);
				
		/*
		//Class/Method
		if(currentModel instanceof UserStory){		 
			Label lblClassMethod = new Label(container,SWT.NONE);
			if(((LinkedDeclaration)currentModel).getType().equals(LinkedDeclaration.LINK_CLASS))
				lblClassMethod.setText(LABEL_CLASS + ((LinkedDeclaration) currentModel).getName());
			else
				lblClassMethod.setText(LABEL_METHOD + ((LinkedDeclaration) currentModel).getName());
		}
		*/
		
		
	
	    return container;
	}

	@Override
	protected void createButtonsForButtonBar(Composite parent){
		//createButton(parent, IDialogConstants.OK_ID, "OK", true);
	}

	@Override
	protected Point getInitialSize()
	{
		return new Point(620, 300);
	}
	@Override
	protected boolean isResizable() {
	    return true;
	}	
	@Override
	protected void okPressed(){	
		super.okPressed();
	}
	
	@Override
	protected void configureShell(Shell newShell) {
	      super.configureShell(newShell);
	      if(currentModel != null)
	    	  newShell.setText(currentModel.getName() + " Properties");
	}
} 
