package ui.dialogs;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import plugin.config.PreferencesManager;

public class TestCaseCancelDialog extends Dialog
{

	@SuppressWarnings("unused")
	@Deprecated
	private boolean deleteUs;
	
	private static String LABEL_WARNING;
	private static String DIALOG_TITLE = "Cancel changes to Test Cases?";

	@SuppressWarnings("unused")
	private static Composite container;
	
	@SuppressWarnings("static-access")
	public TestCaseCancelDialog(Shell parentShell, String warning, boolean deleteUs)
	{
		super(parentShell);
		
		// If multipleObjects is true, plural number of objects.
		this.LABEL_WARNING = warning;
		this.deleteUs = deleteUs;
	}
	
	@Override
	protected boolean isResizable()
	{
	    return true;
	}
	@Override
	protected Point getInitialSize()
	{
		return new Point(400, 150);
	}
	
	@Override
	protected void configureShell(Shell newShell)
	{
	      super.configureShell(newShell);
	      newShell.setText(DIALOG_TITLE);
	}
	
	@Override
	protected Control createDialogArea(Composite parent)
	{		
		Composite container = (Composite) super.createDialogArea(parent);
        
		Label warningLabel = new Label(container,SWT.NONE);
		warningLabel.setText(LABEL_WARNING);
		Button dontShowAgain = new Button(container,SWT.CHECK);
		dontShowAgain.setText("Do not show this message again.");
		dontShowAgain.addSelectionListener(new SelectionAdapter(){
			@Override
			public void widgetSelected(SelectionEvent event)
			{
				Button btn = (Button) event.getSource();
				PreferencesManager.setShowTestCancelDialog(!btn.getSelection());
			}
			
		});
		return parent;
	}
}
